<template>
    <div class="content__leftAnalitika">
        <div class="create-tarif animated fadeInUp">
            <h2 class="title-create">
                <router-link :to="route('plans')">
                    <svg>
                        <use xlink:href="/img/sprite.svg#long-arrow-pointing-to-the-right"/>
                    </svg>
                    {{ $t('ui.back') }}
                </router-link>
                {{ formTitle }}</h2>
            <div class="box-create">
                <form action="" method="POST" @submit.prevent="submit">
                    <p class="text-podskazka"><span>*</span>{{ $t('plans.form.required_help') }} </p>
                    <div class="create__input">
                        <label for="form_name"><span>*</span>{{ $t('plans.form.name') }}</label>
                        <div class="input__svg">
                            <input type="text" required v-model="form.name" id="form_name" name="name"/>
                            <tooltip info="Lorem ipsum dolor sit amet, consectetur adipisicing elit."/>
                        </div>
                    </div>
                    <div class="create__input">
                        <label><span>*</span>{{ $t('plans.form.amount') }}</label>
                        <div class="input__flex">
                            <div class="minMaxLeft">
                                <div class="minMax">
                                    <label for="form_minAmount">{{ $t('ui.min') }}</label>
                                    <input type="number" required id="form_minAmount" v-model="form.min_amount" name="min_amount" step="0.01" />
                                </div>
                                <div class="minMax">
                                    <label for="form_maxAmount">{{ $t('ui.max') }}</label>
                                    <input type="number" required id="form_maxAmount" v-model="form.max_amount" name="max_amount" step="0.01"/>
                                </div>
                            </div>
                            <tooltip info="Lorem ipsum dolor sit amet, consectetur adipisicing elit."/>

                        </div>
                    </div>
                    <div class="create__input">
                        <label for="form_currency"><span>*</span>{{ $t('plans.form.currency') }}</label>
                        <div class="input__svg">
                            <form-select id="form_currency" v-model="form.currency_id" name="currency_id" :options="currencies"
										 :wrapper-style="{width: '393px'}" :span-style="{padding: '15px 0 15px 15px'}" :custom-options-style="{'z-index': 1}"/>
                            <tooltip info="Lorem ipsum dolor sit amet, consectetur adipisicing elit."/>
                        </div>
                    </div>
                    <div class="create__input">
                        <label for="form_percent"><span>*</span>{{ $t('plans.form.percent') }}</label>
                        <div class="input__down">
                            <div class="box__down--left">
                                <div class="box__down--input">
                                    <input type="number" required id="form_percent" step="0.01" min="0.01" v-model="form.percent" name="percent"/>
                                </div>
                                <div class="select-head">
                                    <!--suppress HtmlFormInputWithoutLabel -->
                                    <select v-model="form.type">
                                        <option :value="key" v-for="(label, key) in types">{{ label }}</option>
                                    </select>
                                    <svg class="down">
                                        <use xlink:href="/img/sprite.svg#right-arrow-circular-button"/>
                                    </svg>

                                </div>
                            </div>
                            <tooltip info="Проценты"/>

                        </div>
                    </div>
                    <div class="create__input">
                        <label for="form_duration"><span>*</span>{{ duration_label }}:</label>
                        <div class="input__svg">
                            <input type="number" required id="form_duration" v-model="form.duration" name="duration" min="1"/>
                            <tooltip info="Lorem ipsum dolor sit amet, consectetur adipisicing elit."/>
                        </div>
                    </div>
                    <div class="create__input">
                        <label for="form_amountBonus"><span>*</span>{{ $t('plans.form.amount_bonus') }}</label>
                        <div class="input__svg">
                            <input type="number" required id="form_amountBonus" v-model="form.amount_bonus" name="amount_bonus"/>
                            <tooltip info="Проценты"/>
                        </div>
                    </div>
                    <div class="create__input">
                        <label for="form_balanceBonus"><span>*</span>{{ $t('plans.form.balance_bonus') }}</label>
                        <div class="input__svg">
                            <input type="number" required id="form_balanceBonus" v-model="form.balance_bonus" name="balance_bonus"/>
                            <tooltip info="Проценты"/>
                        </div>
                    </div>
                    <div class="create-check">
                        <div class="check__left">
                            <p class="text-check">{{ $t('plans.form.not_charge_weekends') }}</p>
                            <toggle v-model="form.not_charge_weekends" name="not_charge_weekends"/>
                        </div>
                        <tooltip info="Lorem ipsum dolor sit amet, consectetur adipisicing elit."/>
                    </div>
                    <div class="create-check">
                        <div class="check__left">
                            <p class="text-check">{{ $t('plans.form.can_close') }}</p>
                            <toggle v-model="form.can_close" name="can_close"/>
                        </div>
                        <tooltip info="Lorem ipsum dolor sit amet, consectetur adipisicing elit."/>
                    </div>
                    <div class="create-check">
                        <div class="check__left">
                            <p class="text-check">{{ $t('plans.form.additional_referral_percents') }}</p>
                            <toggle v-model="additional_referral_percents"/>
                        </div>

                        <tooltip info="Lorem ipsum dolor sit amet, consectetur adipisicing elit."/>
                    </div>
                    <div class="create-check">
                        <div class="check__left">
                            <p class="text-check">{{ $t('plans.form.is_limited') }}</p>
                            <toggle v-model="form.is_limited" name="is_limited"/>
                        </div>
                        <tooltip info="Lorem ipsum dolor sit amet, consectetur adipisicing elit."/>
                    </div>
                    <div class="create-check">
                        <div class="check__left">
                            <p class="text-check">{{ $t('plans.form.return_on_close') }}</p>
                            <toggle v-model="return_on_close" name="return_on_close"/>
                        </div>
                        <tooltip info="Lorem ipsum dolor sit amet, consectetur adipisicing elit."/>
                    </div>
                    <div class="create__input" style="margin-top: 30px;" v-if="additional_referral_percents">
                        <label for="form_percentRef">{{ $t('plans.form.additional_referral_percent') }}</label>
                        <div class="input__svg">
                            <input type="text" required id="form_percentRef" />
                            <tooltip info="Lorem ipsum dolor sit amet, consectetur adipisicing elit."/>
                        </div>
                    </div>
                    <div class="create__input" v-if="additional_referral_percents">
                        <label for="form_maxPercent">{{ $t('plans.form.additional_max_percent') }}</label>
                        <div class="input__svg">
                            <input type="text" id="form_maxPercent" required />
                            <tooltip info="Lorem ipsum dolor sit amet, consectetur adipisicing elit."/>
                        </div>
                    </div>
                    <div class="create__input" style="margin-top: 30px;" v-if="form.is_limited">
                        <label for="form_maxDeposits">{{ $t('plans.form.max_deposits') }}</label>
                        <div class="input__svg">
                            <input type="number" id="form_maxDeposits" required v-model="form.max_deposits" name="max_deposits" />
                            <tooltip info="Lorem ipsum dolor sit amet, consectetur adipisicing elit."/>
                        </div>
                    </div>
                    <div class="create__input" style="margin-top: 30px;" v-if="return_on_close">
                        <label for="form_closingPercent">{{ $t('plans.form.return_percent') }}</label>
                        <div class="input__svg">
                            <input type="number" required id="form_closingPercent" v-model="form.return_percent" name="return_percent" step="0.01"/>
                            <tooltip info="Lorem ipsum dolor sit amet, consectetur adipisicing elit."/>
                        </div>
                    </div>

                    <button type="submit">{{ submitLabel }}</button>
                </form>
            </div>
        </div>
    </div>
</template>

<script>
    import Currencies from "../../currencies";
    import _ from 'lodash';
    import {mapGetters} from 'vuex';
    import route from "../../mixins/route";

    export default {
		name: "PlanForm",
        props: ['plan'],
        mixins: [route],
        data(){
			return {
				additional_referral_percents: 0,
				return_on_close: this.plan ? 1 : 0,
                form: {
                    name: this.plan ? this.plan.name : '',
                    min_amount: this.plan ? this.plan.min_amount : '',
                    max_amount: this.plan ? this.plan.max_amount : '',
                    currency_id: this.plan ? this.plan.currency_id : 1,
                    percent: this.plan ? this.plan.percent : 0.00,
                    type: this.plan ? this.plan.type : 'hourly',
                    duration: this.plan ? this.plan.duration : 0,
                    amount_bonus: this.plan ? this.plan.amount_bonus : 0,
                    balance_bonus: this.plan ? this.plan.balance_bonus : 0,
                    not_charge_weekends: this.plan ? +this.plan.not_charge_weekends : 0,
                    is_limited: this.plan ? +this.plan.is_limited : 0,
                    max_deposits: this.plan ? this.plan.max_deposits : 0,
                    can_close: this.plan ? +this.plan.can_close : 0,
                    return_percent: this.plan ? +this.plan.return_percent : 0,
				},
                types: {
                	'hourly': this.$t('plans.percent_type.hourly'),
                	'daily': this.$t('plans.percent_type.daily'),
                }
            }
        },
        computed:{
            ...mapGetters([
                'csrf',
                'axios'
            ]),
			duration_label(){
				return this.$t('plans.form.duration_label.' + this.form.type);
            },
            currencies(){
				let currencies = Currencies.currencies;
				let options = {};
				if(Array.isArray(currencies) && currencies.length){
					_.map(currencies, currency => {
						options[currency.id] = currency.name;
                    });
				}
				return options;
            },
            action(){
			    return this.plan && this.plan.id ? `plans/${this.plan.id}` : `plans`;
            },
            submitLabel(){
				return this.plan && this.plan.id ? this.$t('plans.form.edit_submit') : this.$t('plans.form.create_submit');
            },
            formTitle(){
				return this.plan && this.plan.id ? this.$t('plans.form.edit_title') : this.$t('plans.form.create_title');
            },
        },
        methods: {
			submit(){
				let form_data = Object.assign({
                    _token: this.csrf
                }, this.form);

                this.axios.post(this.action, form_data)
                    .then(resp => resp.data)
                    .then(data => {
                    	if('success' === data.status){
							this.$swal(this.$t('ui.success'))
                                .then(() => {
                                    this.$router.push(this.route('plans'));
                                });
						}else{
							this.$swal(this.$t('ui.error'), data.message, 'error')
                        }
                    })
                    .catch((error) => {
                    	console.log('catch');
                    	let html = '<ul>';
                    	let data = error.response.data;
                    	console.log(data);
                    	_.map(data.errors, (item) => {
							console.log(item);
							if(Array.isArray(item)){
								html += `<li>${item.join('|')}</li>`;
							}
						});
                        this.$swal({
                            title: data.message,
                            html: html,
							type: 'error'
                        });
                    	//this.$swal(data.message, 'message', 'error')
                    });
            }
        }
	}
</script>

<style scoped>

</style>
